//+------------------------------------------------------------------+
//|                                               Indicator35234.mq4 |
//|                                                              ssk |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Hemanth"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 C'0,255,255'
#property indicator_color2 C'255,255,0'
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern int InputSizeArrow=5;//Arrow Size
extern int InputArrowGap=20;//Arrow Gap in Points
extern bool InputAlert=true;//Enable Alert
extern bool InputPushNotification=false;//Enable Push Notification
extern bool InputMail=false;//Enable Mail
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double bufferBuy[];
double bufferSell[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,bufferBuy);
   SetIndexEmptyValue(0,0);
   SetIndexStyle(0,DRAW_ARROW,0,InputSizeArrow);
   SetIndexArrow(0,233);

   SetIndexBuffer(1,bufferSell);
   SetIndexEmptyValue(1,0);
   SetIndexStyle(1,DRAW_ARROW,0,InputSizeArrow);
   SetIndexArrow(1,234);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int s=rates_total-prev_calculated;
   if(s>=1)
     {
      int c0=0;
      for(int i=Bars-1;i>=1;i--)
        {
         double uptrend=iCustom(NULL,0,"QUANTUM",0,i);
         //double downtrend=iCustom(NULL,0,"QUANTUM",1,i);
         if(uptrend!=0)
           {
            if(c0>=0)
              {
               double buyArrow=iCustom(NULL,0,"RSIArrows",2,50,0,i);
               if(buyArrow<2147483647 && buyArrow>0)
                 {
                  bufferBuy[i]=Low[i]-InputArrowGap*Point;
                  c0=-1;
                  if(i==1)
                    {
                     launchAlert(1);
                    }
                 }
              }
           }
         else
           {
            if(c0<=0)
              {
               double sellArrow=iCustom(NULL,0,"RSIArrows",2,50,1,i);
               if(sellArrow<2147483647 && sellArrow>0)
                 {
                  bufferSell[i]=High[i]+InputArrowGap*Point;
                  c0=1;
                  if(i==1)
                    {
                     launchAlert(-1);
                    }
                 }
              }
           }
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void launchAlert(int signal)
  {
   string msg;
   if(signal==1)
     {
      msg=StringConcatenate("Buy Signal: ",Symbol()," ",Period(),
                            " Signal Time: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
     }
   else
     {
      msg=StringConcatenate("Sell Signal: ",Symbol()," ",Period(),
                            " Signal Time: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
     }
   Print(msg);
   if(InputAlert)
     {
      Alert(msg);
     }
   if(InputPushNotification)
     {
      SendNotification(msg);
     }
   if(InputMail)
     {
      SendMail("Indicator35234",msg);
     }
  }

//+------------------------------------------------------------------+
